//
// tbbcrypto - tbbcrypto.cpp
//
#include <iostream>
#include <cstring>
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include "tbb/blocked_range.h"
#include "tbb/parallel_scan.h"

using namespace std;
using namespace tbb;

const int MAX_LEN = 30000;
char plain[MAX_LEN];
char plain2[MAX_LEN];
char cipher[MAX_LEN];

class Crypt {
    char id;
    char * const y;
    const char * const x;
public:
    Crypt( char y_[], const char x_[] ) : id('x'), x(x_), y(y_) {}
    template<typename Tag>
    void operator()( const blocked_range<int>& r, Tag) {
        char temp = id;
        for( int i=r.begin(); i<r.end(); ++i ) {
            temp = temp ^ x[i];
            if( Tag::is_final_scan() )
                y[i] = temp;
        }
    }
    Crypt( Crypt& b, split ) : x(b.x), y(b.y), id('x') {}
    void reverse_join( Crypt& a ) { id = a.id ^ id;}
    void assign( Crypt& b ) {id = b.id;}
};

int main(int argc, char *argv)
{
    plain[0] = '\0';
    // construct data
    for (int i = 0; i < 2; i++) 
        strcat(plain, "Hello, Dogs. I'm Amai Kaori");
    cout << "plain =" << plain << endl;

    int len = strlen(plain);

    task_scheduler_init init;
    
    Crypt crypt(cipher, plain);
    parallel_scan( blocked_range<int>(0, len, 100), crypt );

    init.terminate();

    /* print cipher */
    /*std::cout.setf( std::ios::hex, std::ios::basefield );
	std::cout.setf( std::ios::showbase );
    for (size_t i = 0; i < len; i++) 
        cout << (int)cipher[i] << " ";
    cout << endl;*/

    // decryption
    char temp = 'x';
    plain2[0] = '\0';
    for (size_t i = 0; i < len; i++){ 
        if (i == 0)
            temp ^= cipher[i];
        else
            temp = cipher[i-1] ^ cipher[i];
        plain2[i] = temp;
    }
    plain2[len] = '\0';

    if (strcmp(plain, plain2)==0)
        cout << "plain = plain2" << endl;
    cout << "plain2 =" << plain2 << endl;

    return 0;
}

