//
// tbbaverage - tbbaverage.cpp
//
#include <iostream>
#include <queue>
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include "tbb/blocked_range.h"
#include "tbb/parallel_while.h"

using namespace std;
using namespace tbb;

queue < int > data;

class ItemStream {
    queue <int> * my_ptr;
public:
    bool pop_if_present( queue <int>*& item ) {
        if ( my_ptr ) {
            item = my_ptr;
            if ( !(my_ptr->empty() ) ) {
                my_ptr->pop();
                return true;
            }
        }
        return false;
    }
    ItemStream( queue <int>* root ) : my_ptr(root) {}
};

double total = 0;
int counter = 0;

class ApplyFoo {
    parallel_while<ApplyFoo> &my_while;
public:
    ApplyFoo( parallel_while<ApplyFoo> &w) : my_while(w){}
    void operator()( queue <int>* item ) const {
        if ( !(item->empty())) {
            total += (double) item->front();
            counter++;
            if ((counter % 100) == 0) {
                queue<int>* que = new queue<int>();
                que->push(1000);
                cout << '+' ;
                my_while.add( que );
            }
        }
    }
    typedef queue <int>* argument_type;
};

int main(int argc, char * argv[])
{
    // construct data
    for (int i=0; i<1000; i++){
        int x = 10;
        if (i % 2==0)
            x = 11;
        data.push(x);
    }

    task_scheduler_init init;

    // calc Avarsge
    parallel_while<ApplyFoo> w;
    ItemStream stream(&data);
    ApplyFoo body(w);
    w.run( stream, body );

#ifdef WIN32
    Sleep(10);
#else
    sleep(10);
#endif
    cout << "Total=" << total << endl;
    cout << "Count=" << counter << endl;
    double avr = total / counter;
    cout << "Average=" << avr << endl;

    return 0;
}
