//
// tbbsort - tbbsort.cpp
//
#include <iostream>
#include <cstdlib>
#include "tbb/task_scheduler_init.h"
#include "tbb/parallel_sort.h"

using namespace std;
using namespace tbb;

const int MAX_N = 100000;
const int N = MAX_N;
double dataa[N];
double datab[N];

int main(int argc, char * argv[])
{
    // construct data
    time_t t;
    srand((unsigned int) &t);
    for (int i=0; i<MAX_N; i++){
        dataa[i] = (double)rand();
        datab[i] = (double)rand();
    }

    task_scheduler_init init;

    // sort
    parallel_sort(dataa, dataa + MAX_N);
    for(int i=0; i<50; i++)
        cout << dataa[i] << ", ";
    cout << endl << "=====" << endl;
    for(int i=MAX_N-50; i<MAX_N; i++)
        cout << dataa[i] << ", ";
    cout << endl << endl;

    // reverse sort
    parallel_sort(datab, datab + MAX_N, std::greater<double>());
    for(int i=0; i<50; i++)
        cout << datab[i] << ", ";
    cout << endl << "=====" << endl;
    for(int i=MAX_N-50; i<MAX_N; i++)
        cout << datab[i] << ", ";
    cout << endl;

    return 0;
}
