//
// mtaverage - mtaverage.cpp
//
#include <iostream>
#include "tbb/task_scheduler_init.h"
#include "tbb/concurrent_queue.h"
#include "tbb/parallel_while.h"
#ifdef WIN32
#include <Windows.h>
#else
#include <unistd.h>
#endif

using namespace std;
using namespace tbb;

concurrent_queue < int > data;

class ItemStream {
    concurrent_queue <int> * my_ptr;
public:
    bool pop_if_present( concurrent_queue <int>*& item ) {
        item = my_ptr;
        int n;
        return my_ptr->pop_if_present( n );
    }
    ItemStream( concurrent_queue <int>* root ) : my_ptr(root) {}
};

double total = 0;
int counter = 0;

class ApplyFoo {
    parallel_while<ApplyFoo> &my_while;
public:
    ApplyFoo( parallel_while<ApplyFoo> &w) : my_while(w){}
    void operator()( concurrent_queue <int>* item ) const {
        if ( !(item->empty())) {
            int v = *(item->begin());
            total += (double)v;
            if ((counter % 100) == 0) {
                concurrent_queue<int>* que = new concurrent_queue<int>();
                que->push(1000);
                cout << '+' ;
                my_while.add( que );
                counter++;
            }
        }
    }
    typedef concurrent_queue <int>* argument_type;
};

int main(int argc, char * argv[])
{
    // construct data
    for (int i=0; i<1000; i++){
        int x = 10;
        if (i % 2==0)
            x = 11;
        data.push(x);
    }
    counter = 1000;

    task_scheduler_init init;

    // calc Avarsge
    parallel_while<ApplyFoo> w;
    ItemStream stream(&data);
    ApplyFoo body(w);
    w.run( stream, body );

#ifdef WIN32
    Sleep(5);
#else
    sleep(5);
#endif
    cout << "Total=" << total << endl;
    cout << "Count=" << counter << endl;
    double avr = total / counter;
    cout << "Average=" << avr << endl;

    return 0;
}
