//
// tbbvector - tbbvector.cpp
//
#include <iostream>
#ifdef WIN32
#include <process.h>
#else
#include <pthread.h>
#endif
#include "tbb/task_scheduler_init.h"
#include "tbb/concurrent_vector.h"

using namespace std;
using namespace tbb;

typedef concurrent_vector < char > chr_vector;
chr_vector data;

#ifdef WIN32
unsigned __stdcall addChar(void *arg)
#else
void *addChar(void *arg)
#endif
{
    for(int i=0; i<10; i++){
#ifdef WIN32
        Sleep(1);
#else
        sleep(1);
#endif
        data.push_back('X');
    }

    return(0);
}

#ifdef WIN32
unsigned __stdcall addString(void *arg)
#else
void *addString(void *arg)
#endif
{
    char string[] = "Hello!";
    size_t n = strlen(string);//+1;
    for(int i=0; i<10; i++){
#ifdef WIN32
        Sleep(1);
#else
        sleep(1);
#endif
        memcpy( &data[data.grow_by(n)], string, n+1 );
    }

    return(0);
}

int main(int argc, char * argv[])
{
    task_scheduler_init init;

    // construct data
    for (int i=0x30; i<0x3A; i++){
        char c = (char)i;
        data.push_back((const char) c);
    }

#ifdef WIN32
    unsigned    dummy;
    uintptr_t thread1 =_beginthreadex(NULL, 0, addChar, (void *)NULL, 0, &dummy);
    if(thread1 == 0){
        cout << "thread1 pthread_create error" << endl;
        return -1;
    }
    uintptr_t thread2 =_beginthreadex(NULL, 0, addString, (void *)NULL, 0, &dummy);
    if(thread2 == 0){
        cout << "thread2 pthread_create error" << endl;
        return -1;
    }
#else
    pthread_t thread1;
    int status = pthread_create(&thread1, NULL, addChar, (void *)NULL);
    if(status != 0){
        cout << "thread1 pthread_create error" << endl;
        return -1;
    }
    pthread_t thread2;
    status = pthread_create(&thread2, NULL, addString, (void *)NULL);
    if(status != 0){
        cout << "thread2 pthread_create error" << endl;
        return -1;
    }
#endif

#ifdef WIN32
    WaitForSingleObject((HANDLE)thread1, INFINITE);
    WaitForSingleObject((HANDLE)thread2, INFINITE);
#else
    pthread_join( thread1, NULL );
    pthread_join( thread2, NULL );
#endif

    // Output data
    ostream_iterator <char, char> out(cout, ",");
    copy(data.begin(), data.end(), out);
    cout << endl;

    return 0;
}

