//
// global - global.cpp
//
#include <iostream>
#include <cstdio>
#include <string>
#ifdef WIN32
#include <Windows.h>
#include <process.h>
#else
#include <pthread.h>
#endif
#include "tbb/task_scheduler_init.h"
#include "tbb/concurrent_vector.h"
#include "tbb/atomic.h"

using namespace std;
using namespace tbb;

concurrent_vector <string> result;
atomic <int> atomicv;
int globalv = 0;

const int nThread = 10;
const int nLoop = 10;

#ifdef WIN32
unsigned __stdcall countup(void *arg)
#else
void *countup(void *arg)
#endif
{
    int cc = (int) arg;
    char c = (char) cc;
    for(int i=0; i<nLoop; i++){
#ifdef WIN32
        Sleep(1);
#else
        sleep(1);
#endif
        char buff[256];
        sprintf(buff, "(%c) globalv=%d atomicv=%d", 
            c, globalv, atomicv.fetch_and_increment());
        result.push_back(buff);
        globalv++;
    }

#ifdef WIN32
    return(0);
#endif
}

int main(int argc, char * argv[])
{
    task_scheduler_init init;

    atomicv = 0;

#ifdef WIN32
    unsigned    dummy;
    uintptr_t thread[nThread];
    for (int i=0; i<nThread; i++) {
        thread[i] =_beginthreadex(NULL, 0, countup, (void *)(char)('a'+i), 0, &dummy);
        if(thread[i] == 0){
            cout << "thread1 pthread_create error" << endl;
            return -1;
        }
    }
#else
    pthread_t thread[nThread];
    for (int i=0; i<nThread; i++) {
        int status = pthread_create(&thread[i], NULL, countup, (void *)(char)('a'+i));
        if(status != 0){
            cout << "thread1 pthread_create error" << endl;
            return -1;
        }
    }
#endif

#ifdef WIN32
    for (int i=0; i<nThread; i++)
        WaitForSingleObject((HANDLE)thread[i], INFINITE);
#else
    for (int i=0; i<10; i++)
        pthread_join( thread[i], NULL );
#endif

    // Output atomicv
    concurrent_vector <string>::iterator iter;
    for (iter = result.begin(); iter<result.end(); iter++)
        cout << *iter << endl;

    return 0;
}
